// Viterbi.cpp : ܼ  α׷   մϴ.
//

#include "stdafx.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#define max2( a , b ) ( (a) < (b) ? (b) : (a) )
#define max3( a, b, c )  max2( (a) , max2( (b), (c) ) )
#define max4( a, b, c, d )  max3( (a) , (b), max2( (b), (c) ) )



int _tmain(int argc, _TCHAR* argv[])
{




// DATA 1
//*
	#define nr_states			2		// hidden state   
	#define nr_visibles			3		// visible output   
	#define nr_observations		3		//  visibles  

	// hidden_states
	#define RAINY 0
	#define SUNNY 1

	// visible_observations (  0 )
	#define WALK  0
	#define SHOP  1
	#define CLEAN 2

	// hidden_states  
	int states[nr_states] = { RAINY, SUNNY };
	
	//  				Output data
	int observation[nr_observations] = { WALK, SHOP, CLEAN };

	//  Ȯ prior			w
	float start_probability[nr_states] = {0.6,0.4};		// hidden state ʱ Ȯ 

	// Transition matrix		A
	float transiton_probability[nr_states][nr_states] = { {0.7,0.3},{0.4,0.6} };

	// Emission matrix			B
	float emission_probability[nr_states][nr_visibles]  = { {0.1,0.4,0.5 }, {0.6,0.3,0.1 }};
//*/	

/*/ DATA 2
	#define nr_states			3		// hidden state   
	#define nr_visibles			2		// visible output   
	#define nr_observations		3		//  visibles  

	// hidden_states
	#define U1  0
	#define U2  1
	#define U3	2
	
	// visible_observations (  0 )
	#define RED 0
	#define BLUE 1

	// hidden_states  
	int states[nr_states] = { U1, U2 , U3  };

	//  				Output data
	int observation[nr_observations] = { RED, BLUE, RED };

	//  Ȯ prior			w
	float start_probability[nr_states] = {0.3333333333, 0.3333333333, 0.3333333333};		// hidden state ʱ Ȯ 

	// Transition matrix		A
	float transiton_probability[nr_states][nr_states] = { {0.3, 0.6, 0.1}, {0.5, 0.2, 0.3} , {0.4, 0.1, 0.5} };

	// Emission matrix			B
	float emission_probability[nr_states][nr_visibles]  = { {0.5 , 0.5} , {0.3333333333 , 0.6666666666}  , {0.75 , 0.25} };
//*/


	//////////////////////////////////////////////////////////////////////////////////////////////
	//								viterbi path  غ								//
	//////////////////////////////////////////////////////////////////////////////////////////////
	int path_temp[nr_states][nr_observations];
	int vpath[nr_observations];

	float v[nr_states][nr_observations + 1];	// 1   ʱ 0 ϱ ؼ̴.

	for (int time = 0; time <= nr_observations; time++)
	{
		//  ð print
		printf("\n\ntime: %d\n", time);

		if(time == 0)
		{
			// time = 0,  ó ʱȭ Ѵ. 
			for (int i = 0; i<nr_states; i++)
			{
				v[i][time] = start_probability[i];
				printf("v%d: %f \n", i, v[i][time] );
			}
		}
		else if(time ==1)
		{
			// time = 1    ó trasition Ͼ ʴ´. 
			for (int i = 0; i<nr_states; i++)
			{
				// time == 1 Ȯ  Ȯ * emission_prob
				v[i][time] = v[i][time-1] * emission_probability[i][ observation[time-1] ];

				printf("v%d: %f \n", i,v[i][time]);
			}
		}
		else
		{
			// time > 1      state  ִ밪 ؾ Ѵ. 
			for (int i = 0; i < nr_states; i++)
			{
				//printf("state: %d \n", i);
				//  state ؼ ִ밪 Ѵ. 
				float v_max = 0, v_temp;
				int v_max_j = 0;
				for (int j = 0; j < nr_states; j++)
				{
					//j t-1  state Ѵ. 
					v_temp = v[j][time-1] * transiton_probability[j][i];
					//printf("v_temp%d: %f \n", i,v_temp);
					if( v_temp > v_max )
					{
						v_max = v_temp;
						v_max_j = j;
					}
				}
				// v_max  state i  ִv ִ. 
				// v_max_j  state ִ   t-1 state ȣ ִ. 
				
				// 
				path_temp[i][time-1] = v_max_j;
				//printf("max_j: %d \n", path_temp[i][time-1]);


				v[i][time] = v_max * emission_probability[i][ observation[time-1] ];
				printf("v%d: %f \n", i,v[i][time]);
			}

			//  ð t  state Ȯ ִ. 
			//  state߿ ִ밪 . 
			float v_max_temp = 0;
			int v_max_i_temp = 0;
			for (int i = 0; i < nr_states; i++)
			{
				// path Ѵ. time-2   time 2  1 path   ֱ ̰, C 迭 0 ϱ ̴.
				//  path[0] time=1 hidden ¸ Ÿ. 

				if ( v_max_temp < v[i][time] )
				{
					v_max_temp = v[i][time] ;
					v_max_i_temp = i;

					//  ̻ϱ  ̷ ϸ ɵ 
					vpath[nr_observations-1] = v_max_i_temp;
				}
			}
			vpath[time - 2] = path_temp[v_max_i_temp][time-1];
		}
		
	} // for (int time = 0; time <= nr_observations; time++) //
	//  path  Ȯ   Ѵ. 
	


	//* viterbi path  
	for (int time = 0; time < nr_observations; time++) 
	{
		printf("path%d: %d \n", time, vpath[time] );
	}
	//*/



	return 0;
}
